//+------------------------------------------------------------------+
//|                                                            1.mq4 |
//|                                                        Korsun E. |
//|                                                                1 |
//+------------------------------------------------------------------+
#property copyright "Korsun E."
#property link      "1"

#define MAGICMA  20110707

//extern double    lots=0.1;
extern int       fast_ma_period=9;
extern int       slow_ma_period=55;
extern int       ma_method=0;
extern int       applied_price=0;
extern double TakeProfit=500;
extern double Lots=0.1;
extern double TrailingStop = 0;
extern double StopLoss=60;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
    
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   int cnt, ticket, total;
   
     if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
 //  if(TakeProfit<10)
   //  {
     // Print("TakeProfit less than 10");
     // return(0);  // check TakeProfit
     //}
     
   double fma_prev=double iMA( Symbol(), 0, fast_ma_period, 0, ma_method, applied_price, 0);
   double fma_next=double iMA( Symbol(), 0, fast_ma_period, 0, ma_method, applied_price, 1);
   
   double sma_prev=double iMA( Symbol(), 0, slow_ma_period, 0, ma_method, applied_price, 0);
   double sma_next=double iMA( Symbol(), 0, slow_ma_period, 0, ma_method, applied_price, 1);
   total=OrdersTotal();
   if (total<1){ //  ,        
      if(AccountFreeMargin()<(1000*Lots)){//    
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
      }
      
      if(fma_prev<sma_prev && fma_next>=sma_next){ //   BUY
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Bid-StopLoss*Point,Ask+TakeProfit*Point,"BUY",MAGICMA,0,Green);
         if(ticket>0){//     
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))//    
               Print("BUY order opened : ",OrderOpenPrice());
            }
            else Print("Error opening BUY order : ",GetLastError()); 
            return(0);
      }
      
      if(fma_prev>=sma_prev && fma_next<sma_next){ //   SELL        
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Ask+StopLoss*Point,Bid-TakeProfit*Point,"SELL",MAGICMA,0,Red);
         if(ticket>0){
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) 
               Print("SELL order opened : ",OrderOpenPrice());
         }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
      }               
   } 
   
   //     
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   //   ? OP_BUY  OP_SELL  
         OrderSymbol()==Symbol())  //  ?
        {
         if(OrderType()==OP_BUY)   //   
           {
            // ,    ?
            if(fma_prev>=sma_prev && fma_next<sma_next)
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); //  
                 return(0); 
                }
            //   -  /    ?
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else //  -  
           {
            // ,    ?
            if(fma_prev<sma_prev && fma_next>=sma_next)
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); //  
               return(0); 
              }
            //  -  /    ?
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+